#include <termios.h>
#include <stdio.h>
#define STDIN_FILENO 0
#define FALSE 0
#define TRUE 1

int bioskey()
{
    static int structValid = FALSE;
    static struct termios original, modified;
    int retval;

    if (!structValid)
    {
       ioctl(STDIN_FILENO,TCGETS,&original);
       bcopy((char *)&original, (char *)&modified, sizeof(struct termios));
       modified.c_lflag &= (~ICANON);         /* character input */
       modified.c_cc[VMIN] = 0;               /* minimum number of characters */
       modified.c_cc[VTIME] = 0;              /* do not wait */
       structValid = TRUE;
    }

    ioctl(STDIN_FILENO,TCSETS,&modified);
    retval = getc(stdin);

    if (feof(stdin))
    {
       retval = 0;
       clearerr(stdin);
    }

    ioctl(STDIN_FILENO,TCSETS,&original);
    return(retval);
}
